#ifdef DREAMCAST
#include <kos.h>
extern uint8 romdisk[];
KOS_INIT_FLAGS(INIT_DEFAULT);
KOS_INIT_ROMDISK(romdisk);
#endif

#include <stdio.h>

#include "dcastaway.h"
#include "menu.h"
#include "mem.h"
#include "disk.h"

#ifdef GP2X
#include <fcntl.h>
#include <unistd.h>
#endif

#ifdef DREAMCAST
static uint32 dcastaway_dc_args[4]={ 0, 0, 0, 0};
static void dcastaway_dreamcast_handler(irq_t source, irq_context_t *context)
{
	irq_create_context(context,context->r[15], (uint32)&emergency_reset, (uint32 *)&dcastaway_dc_args[0],0);
}

static void init_dreamcast_handlers(void)
{
    irq_set_handler(EXC_USER_BREAK_PRE,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_INSTR_ADDRESS,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_ILLEGAL_INSTR,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_SLOT_ILLEGAL_INSTR,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_GENERAL_FPU,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_SLOT_FPU,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_DATA_ADDRESS_WRITE,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_DTLB_MISS_WRITE,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_OFFSET_000,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_OFFSET_100,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_OFFSET_400,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_OFFSET_600,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_FPU,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_TRAPA,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_RESET_UDI,&dcastaway_dreamcast_handler);
    irq_set_handler(EXC_UNHANDLED_EXC,&dcastaway_dreamcast_handler);
}
#else
#define init_dreamcast_handlers()
#endif

int main(int argc, char *argv[])
{
#ifdef DREAMCAST
#if defined(DEBUG_FRAMESKIP) || defined(DEBUG_SAVESTATE) || defined(DEBUG_FILEMANAGER)
	puts("Main!!!!");
#endif
#endif
#ifdef GP2X
	int mmufd = open("/dev/mmuhack", O_RDWR);
	if(mmufd < 0) {
		system("/sbin/insmod ./mmuhack.o");
		mmufd = open("/dev/mmuhack", O_RDWR);
	}
	if(mmufd < 0) return 0;
 	close(mmufd); 
#endif
	init_text(1);
	while (MemInit())
		drawNoRom();
	run_mainMenu();
	quit_text();
	initDisk();
	init_dreamcast_handlers();
	while(1)
		dcastaway();
#if 0
	quitDisk();
    	MemQuit();
#endif
	return 0;
}

int run_menuGame() { return 0; }
int run_menuControl() { return 0; }

